(08/2015)

This template is an update of Apple’s Xcode4 AudioUnit effect AUv2 ’aufx’ template.  It will build an AudioUnit with all the relevant additions to make it as currently-and-backward compatible as possible.  I have tested it up through Xcode 7.0/10.11 SDK, in both universal-32/64 and 64-only modes.  The carbon *.rez file will allow the plugin to be opened in older DAWs/hosts.  Apple is likely to depreciate these methods in the near future though…

NOTES ON USING THIS TEMPLATE:

1) Apple keeps moving the ‘Developer’ directory… drop this template in either ‘<<user home>>/Library/Developer/Xcode/Templates’ or ‘/Applications/Xcode.app/Contents/Developer/Library/Xcode/Templates’

2) Make sure to have Apple's Core Audio Utility classes' "CoreAudio" folder in the top level of your developer directory: the default now is in the Xcode.app:  /Applications/Xcode.app/Contents/Developer/…. (You can alternatively change the path to the source files in the *.xctemplate if you prefer).

3) I did not add an installer script, but here is the one I use if you would like to add it to your primary target’s run script build phase.  It will move the built plugin to your user plugin folder after deleting any older versions in there with the same name:

rm -rf $HOME/Library/Audio/Plug-Ins/Components/$PRODUCT_NAME.component
cp -r "$BUILT_PRODUCTS_DIR/$PRODUCT_NAME.component" "$HOME/Library/Audio/Plug-Ins/Components/$PRODUCT_NAME.component"

4) If you want to re-use this for your own custom template, see the bottom of this file for the macros that I used in the new project options menu.

5) v2 AUs are trailing behind the SDKs, so if you use the newer SDKs, you might want to turn off depreciated function warnings in your build settings (or add it to this template). Search your build settings for ‘GCC_WARN_ABOUT_DEPRECATED_FUNCTIONS’ and set it to ‘NO’

6) the only deviations from the standard Apple default Cocoa bundle build settings are that I turned off ARC and added some rez settings and paths.  You can easily modify those to suit your needs.

Happy coding!
- Alex Kenis



RELEVANT MACROS — for use in converting a current project to a template
———————————————————————————————————————————————————————————————————————

STANDARD MACROS
Project/bundle/executable Name:
___PROJECTNAMEASIDENTIFIER___

Company name:
___ORGANIZATIONNAME___


CUSTOM MACROS
Manufacturer 4-char code:
___VARIABLE_bundleIdentifierPrefix:bundleIdentifier___

Unique 4-char subtype identifier:
___VARIABLE_effectSubType:identifier___
